
const electron = require('electron')
// Module to control application life.
const app = electron.app
//const {ipcMain} = require('electron')
var path = require('path')
const url = require('url')
const {session, dialog} = require('electron')

// Module to create native browser window.
const BrowserWindow = electron.BrowserWindow
//Adds the main Menu to our app

// Keep a global reference of the window object, if you don't, the window will
// be closed automatically when the JavaScript object is garbage collected.

let mainWindow
let loading
//let secondWindow





/*
function sendStatusToWindow(text) {
  log.info(text);
 // mainWindow.webContents.executeJavaScript(console.log(text));
  mainWindow.webContents.send('message', text);
}
*/
function createWindow () {
	// Create the browser window.

	if (mainWindow == undefined) {
		mainWindow = new BrowserWindow({titleBarStyle: 'default',
			title: "Outplanr",
			width: 1280,
			height: 700,
			minWidth: 1024,
			minHeight: 600,
			backgroundColor: '#f0f0f0',
			show: false,
			icon: path.join(__dirname, 'assets/icons/png/64x64.png')
		})
	}

  	// and load the index.html of the app.

  
  	//mainWindow.webContents.executeJavaScript(console.log('start'))
  	
  // Open the DevTools.
//mainWindow.webContents.openDevTools()



  // Show the mainwindow when it is loaded and ready to show
/*
  mainWindow.once('ready-to-show', () => {
    mainWindow.show()
  })
*/

  // Emitted when the window is closed.
  mainWindow.on('closed', function () {
    // Dereference the window object, usually you would store windows
    // in an array if your app supports multi windows, this is the time
    // when you should delete the corresponding element.
    mainWindow = null
  
  })


 require('./menu/mainmenu')
		  
	  
	  mainWindow.webContents.once('dom-ready', () => {
		      setTimeout(function(){
			     removeLoader()
			  }, 2600);
		      
		      
		    })
//loading.webContents.openDevTools()
}



/*
ipcMain.on('online-status-changed', (event, status) => {
  console.log(status)
})
*/
// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
app.on('ready',start)

// Quit when all windows are closed.


app.on('window-all-closed', function () {
  // On OS X it is common for applications and their menu bar
  // to stay active until the user quits explicitly with Cmd + Q
  if (process.platform !== 'darwin') {	
    app.quit()
  }
})

app.on('activate', function () {
  // On OS X it's common to re-create a window in the app when the
  // dock icon is clicked and there are no other windows open.
	if (mainWindow === null) {
		start()
	}
})

// In this file you can include the rest of your app's specific main process
// code. You can also put them in separate files and require them here.


function checkStatus(){
	 setInterval(function(){  
		if(mainWindow != undefined){
			require('dns').lookup('www.google.com', function(err) {
				if (err!=null || err!=undefined) {
/*
					if(mainWindow.webContents.history[mainWindow.webContents.currentIndex]==undefined || mainWindow.webContents.history.length==0){
						session.defaultSession.cookies.get({}, (error, cookies) => {
							domain_exist =`https://www.outplanr.net`;
							for(var i = 0; i < cookies.length; i++) {
								if(cookies[i].name == "fwlbeifblsj" ){
									domain_exist = "https://"+cookies[0].domain;
								}
							}		
						mainWindow.loadURL(domain_exist)
						removeLoader();
						})
					}else{
					   if(mainWindow.webContents.history[mainWindow.webContents.currentIndex].indexOf("error.html") == -1 || mainWindow.webContents.history.length==0) {

						    
					      mainWindow.loadURL(url.format({
						    pathname: path.join(__dirname, 'error.html'),
						    protocol: 'file:',
						    slashes: true
						  }))
						  
						  removeLoader();
					  }
				  }
*/
				} else {
				    if(mainWindow.webContents.history[mainWindow.webContents.currentIndex]==undefined || mainWindow.webContents.history.length==0){
					    setTimeout(function(){
/*
						    if(mainWindow.webContents.history[mainWindow.webContents.currentIndex].indexOf("error.html") > -1) {
								if((mainWindow.webContents.currentIndex-1)>0){
									mainWindow.loadURL(mainWindow.webContents.history[mainWindow.webContents.currentIndex-1])  
								}else{
*/
									 
									session.defaultSession.cookies.get({}, (error, cookies) => {
										 mainWindow.webContents.executeJavaScript("console.log('3.1.1')")
										domain_exist =`https://www.outplanr.net`;
										for(var i = 0; i < cookies.length; i++) {
											if(cookies[i].name == "fwlbeifblsj" ){
												domain_exist = "https://"+cookies[0].domain;
											}
										}		
										mainWindow.loadURL(domain_exist)
									})
									removeLoader();
// 								}}
				
							}, 1000);
				    }else{
					   if(mainWindow.webContents.history[mainWindow.webContents.currentIndex].indexOf("error.html") > -1) {
							if((mainWindow.webContents.currentIndex-1)>0 && mainWindow.webContents.history[mainWindow.webContents.currentIndex-1].indexOf("error.html") == -1 ){
								mainWindow.loadURL(mainWindow.webContents.history[mainWindow.webContents.currentIndex-1])  
							}else{
								session.defaultSession.cookies.get({}, (error, cookies) => {
									domain_exist =`https://www.outplanr.net`;
									for(var i = 0; i < cookies.length; i++) {
										if(cookies[i].name == "fwlbeifblsj" ){
											domain_exist = "https://"+cookies[0].domain;
										}
									}		
								mainWindow.loadURL(domain_exist)
								})
								removeLoader();
							}
							
							
						}else{
						
							if(mainWindow.webContents.history[mainWindow.webContents.currentIndex].indexOf("outplanr.net") == -1){
								mainWindow.webContents.clearHistory()
								session.defaultSession.cookies.remove()
							}else{
								
							}
						}
				    }
				}
			});
		}
    }, 5000);

}

function start(){
	loading = new BrowserWindow({width: 500,
			height: 500,
			maxWidth: 500,
			maxHeight: 500,
			backgroundColor: '#fff',
			show: false,
			frame: false})
	loading.loadURL(url.format({
	    pathname: path.join(__dirname, 'index.html'),
	    protocol: 'file:',
	    slashes: true
		}))
	  loading.show()

	const cookie = {url:"https://www.outplanr.net",domain:".outplanr.net", expirationDate:"Mon, 18 Dec 2084 12:00:00 UTC", name: 'appDesktop', value: 'true'}
	session.defaultSession.cookies.set(cookie, (error) => {
		if (error) console.error(error)
	})
	if (mainWindow == undefined) {	  
		createWindow()
	}
	
	
/*
	while(mainWindow ==""){
		setTimeout(function(){}, 200);
	}
*/

	
	require('dns').lookup('www.google.com', function(err) {
		
		
		  if (err!=null) {
			  loading.loadURL(url.format({
			    pathname: path.join(__dirname, 'error.html'),
			    protocol: 'file:',
			    slashes: true
	  		}))
	  	
	  		//removeLoader();
		  }else{
			 loading.once('show', () => {
   
			    mainWindow.webContents.once('dom-ready', () => {
				      setTimeout(function(){
					        console.log('main end')
					     removeLoader()
					  }, 2600);
				      
				      
				    })
			  })
		  
		  
				session.defaultSession.cookies.get({}, (error, cookies) => {
					domain_exist =`https://www.outplanr.net`;

					for(var i = 0; i < cookies.length; i++) {
						if(cookies[i].name == "fwlbeifblsj" ){
							if(!cookies[0].domain.includes("outplanr")){
								mainWindow.webContents.clearHistory()
								session.defaultSession.clearStorageData()
							}else{
								domain_exist = "https://"+cookies[0].domain;
							}
							
						}
					}		
					mainWindow.loadURL(domain_exist)
				})			 
		  }
		  checkStatus();

	})

}

function removeLoader(){
	mainWindow.show()

	if(typeof loading != "undefined"){
		loading.hide()
		//loading.close()
	}
	
}

